package info.textgrid.middleware;

import info.textgrid.middleware.oaipmh.ListMetadataFormatsType;
import info.textgrid.middleware.oaipmh.MetadataFormatType;
import info.textgrid.middleware.oaipmh.RequestType;

/**
 *
 */
public abstract class MetadataFormatListDelivererAbs
    implements MetadataFormatListDelivererInterface {

  //
  // CLASS
  //

  private boolean idExist = true;

  /**
   * @param textgrid
   * @param dariah
   */
  public MetadataFormatListDelivererAbs() {
    //
  }

  /*
   * (non-Javadoc)
   * 
   * @see info.textgrid.middleware.MetadataFormatListDelivererInterface#setMetadataFormatList()
   */
  public ListMetadataFormatsType setMetadataFormatList() {

    ListMetadataFormatsType result = new ListMetadataFormatsType();

    // Add default metadata format (oai_dc).
    MetadataFormatType mft = new MetadataFormatType();
    mft.setMetadataPrefix(OAIPMHUtilities.OAIDC_PREFIX);
    mft.setMetadataNamespace(OAIPMHUtilities.OAIDC_NAMESPACE);
    mft.setSchema(OAIPMHUtilities.OAIDC_SCHEMA_LOCATION);
    result.getMetadataFormat().add(mft);

    // Add metadata format for OPEN AIRE.
    MetadataFormatType mftOpenAire = new MetadataFormatType();
    mftOpenAire.setMetadataNamespace(OAIPMHUtilities.OPEN_AIRE_NAMESPACE);
    mftOpenAire.setMetadataPrefix(OAIPMHConstants.METADATA_OPENAIRE_PREFIX);
    mftOpenAire.setSchema(OAIPMHUtilities.OPEN_AIRE_SCHEMA_LOCATION);
    result.getMetadataFormat().add(mftOpenAire);

    return result;
  }

  /*
   * (non-Javadoc)
   * 
   * @see
   * info.textgrid.middleware.MetadataFormatListDelivererInterface#requestChecker(info.textgrid.
   * middleware.oaipmh.RequestType)
   */
  public boolean requestChecker(RequestType request) {

    boolean requestCheck = true;

    if (request.getFrom() != null
        || request.getMetadataPrefix() != null
        || request.getResumptionToken() != null) {
      requestCheck = false;
    } else if (request.getSet() != null
        || request.getUntil() != null) {
      requestCheck = false;
    }

    return requestCheck;
  }

  //
  // GETTERS & SETTERS
  //

  /**
   * @return
   */
  public boolean isIdExist() {
    return this.idExist;
  }

  /**
   * @param idExist
   */
  public void setIdExist(boolean idExist) {
    this.idExist = idExist;
  }

}
